Attribute VB_Name = "Sample"
'============================================================================
'
'  PA-S500
'
'  Ver.1.00 Date 2011/09/09
'
'   ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'
'============================================================================
Option Explicit

Private Const szTitle = "Sample"
Private Const szPAS = "PA-S500"
Private Declare Function GetLastError Lib "kernel32" () As Long

'============================================================================
'   ۸т̊Jn
'============================================================================
Sub Main()

  Dim wLogSlot As Integer      ' ޲̘_ۯĔԍi[
  Dim Ri As PAS500RESOURCE     ' ؿ
  Dim dwSwVal As Long          ' ۰ذ̒l
  Dim dwDirections As Long     ' ިڸ
  Dim cbDat As Byte
  Dim bResult As Boolean       ' 
  Dim szBuf As String

  '-------------------------------------------------
  ' pas500.dll ̎gp錾
  '-------------------------------------------------
  If Pas500wDllOpen() = False Then
    ErrorMessage (PAS500_SLOT_AUTO)
    Exit Sub                   ' pas500.dll ۰ނɎs܂
  End If
  '-------------------------------------------------
  ' PA-S500̎gp錾
  '-------------------------------------------------
  wLogSlot = PAS500_SLOT_AUTO            ' gp޲T܂B
  bResult = Pas500wCreate(wLogSlot)      ' ꍇA̎޲̘_ۯĔԍi[܂B

  If bResult = False Then                ' ޲܂B
    ErrorMessage (PAS500_SLOT_AUTO)
    Exit Sub
  End If

  szBuf = "PA-S500 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)
  ResultMessage (szBuf)
  '-------------------------------------------------
  ' ؿ۰ذ̒l擾
  '-------------------------------------------------
  If Pas500wGetResource(wLogSlot, Ri) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If

  If Pas500wGetSwitchValue(wLogSlot, dwSwVal) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If

  szBuf = "Board Name  " + Chr(9) + ": " + szPAS + Chr(10) + _
          "IO Address  " + Chr(9) + ": &H" + Hex(Ri.dwIOPortBase(1)) + _
          "-&H" + Hex(Ri.dwIOPortBase(1) + Ri.dwIOPortLength(1) - 1) + Chr(10) + _
          "Switch      " + Chr(9) + ": &H" + Hex(dwSwVal)

  ResultMessage (szBuf)
  '-------------------------------------------------
  ' Port A ިڸ݂o͂ɐݒ肷
  '-------------------------------------------------
  If Pas500wGetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  dwDirections = (Not PAS500_DIR_A_INPUT) And dwDirections   ' A Port ޯĂo͂ɕύX܂B
  If Pas500wSetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  ResultMessage ("Port A ̃fBNVo͂ɕύX")
  '-------------------------------------------------
  ' Port A ɔCӂ̃f[^o
  '-------------------------------------------------
  cbDat = &HAA
  If Pas500wOutPort(wLogSlot, PAS500_PORT_A, cbDat) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If

  szBuf = "Port A փf[^o" + Chr(10) + _
          "Port A Out Data: &H" + Hex(cbDat)

  ResultMessage (szBuf)
  '-------------------------------------------------
  ' Port A ިڸ݂͂ɐݒ
  '-------------------------------------------------
  If Pas500wGetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  dwDirections = PAS500_DIR_A_INPUT Or dwDirections   ' A Port ޯĂ͂ɕύX܂B
  If Pas500wSetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  ResultMessage ("Port A ̃fBNV͂ɕύX")
  '-------------------------------------------------
  ' Port A f[^ǂݍ
  '-------------------------------------------------
  cbDat = &H0
  If Pas500wInPort(wLogSlot, PAS500_PORT_A, cbDat) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  szBuf = "Port A f[^" + Chr(10) + _
          "Port A In Data: &H" + Hex(cbDat)

  ResultMessage (szBuf)
  '-------------------------------------------------
  ' PA-S500̎gpJ
  '-------------------------------------------------
  If Pas500wClose(wLogSlot) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  ResultMessage ("PA-S500 Closed")
  '-------------------------------------------------
  ' pas500.dll ̎gpJ
  '-------------------------------------------------
  If Pas500wDllClose() = False Then
    MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
    Exit Sub
  End If
End Sub
'============================================================================
'    ʂ\
'============================================================================
Private Sub ResultMessage(lpszbuf As String)
  MsgBox lpszbuf, vbOKOnly + vbInformation
End Sub
'============================================================================
'    G[bZ[W\
'============================================================================
Private Sub ErrorMessage(ByVal wLogSlot As Integer)
  Dim dwRes As Long
  Dim szBuf As String

  dwRes = Pas500wGetLastError(wLogSlot)
  Select Case dwRes
    Case PAS500_ERR_SYSTEM
      szBuf = "System error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(GetLastError())
    Case PAS500_ERR_WRAPDLL
      szBuf = "DLL Load error"
    Case Else
      szBuf = "PA-S500 error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(dwRes)
  End Select
  MsgBox szBuf, vbOKOnly + vbCritical
End Sub


