Attribute VB_Name = "Wrapper"
'============================================================================
'   PA-S500
'
'   Ver.1.01 Date 2012/02/28
'
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const PAS500_DLL_NAME = "pas500.dll" ' DLL
Global Const PAS500_ERR_WRAPDLL = -1        ' ׯ߰֐װ

Dim hDLL As Long                'DLLւ

'============================================================================
'     pas500.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Pas500wDllOpen() As Boolean
  Pas500wDllOpen = False
  If hDLL = 0 Then
    hDLL = LoadLibrary(PAS500_DLL_NAME)
    If hDLL <> 0 Then
      Pas500wDllOpen = Pas500wGetDllExportFunc()
      If Pas500wDllOpen <> True Then
        Pas500wDllClose       ' DLL֐擾ɎŝDLL۰
      End If
    End If
  End If
End Function
'============================================================================
'     pas500.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Pas500wDllClose() As Boolean
  Pas500wDllClose = False
  If hDLL <> 0 Then
    If FreeLibrary(hDLL) <> 0 Then
      hDLL = 0
      Pas500wDllClose = True
    End If
  End If
End Function
'============================================================================
'     PA-S500̔Cӂ޲̎gp錾
'     pwLogSlot  gp޲̘_ۯĔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Pas500wCreate(pwLogSlot As Integer) As Boolean
  Pas500wCreate = False
  If hDLL <> 0 Then
    If Pas500Create(pwLogSlot) <> 0 Then
      Pas500wCreate = True
    End If
  End If
End Function
'============================================================================
'     PA-S500̔Cӂ޲̎gpJ
'     wLogSlot ޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Pas500wClose(ByVal wLogSlot As Integer) As Boolean
  Pas500wClose = False
  If hDLL <> 0 Then
    If Pas500Close(wLogSlot) <> 0 Then
      Pas500wClose = True
    End If
  End If
End Function
'============================================================================
'     w޲ؿ擾
'     wLogSlot ؿ擾޲̘_ۯĔԍ
'         pResInfo ؿi[\
'  ߂l  True
'         s False
'============================================================================
Function Pas500wGetResource(ByVal wLogSlot As Integer, pResInfo As PAS500RESOURCE) As Boolean
  Pas500wGetResource = False
  If hDLL <> 0 Then
    If Pas500GetResource(wLogSlot, pResInfo) <> 0 Then
      Pas500wGetResource = True
    End If
  End If
End Function
'============================================================================
'     ۰ذ̒l擾
'     wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ
'         pdwSwitchValue ۰ذ̒li[
'  ߂l  True
'         s False
'============================================================================
Function Pas500wGetSwitchValue(ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Boolean
  Pas500wGetSwitchValue = False
  If hDLL <> 0 Then
    If Pas500GetSwitchValue(wLogSlot, pdwSwitchValue) <> 0 Then
      Pas500wGetSwitchValue = True
    End If
  End If
End Function
'============================================================================
'     ިڸ݂̏Ԃ擾
'     wLogSlot      ިڸݏ擾޲̘_ۯĔԍ
'         pdwDirections Ԃi[
'  ߂l  True
'         s False
'============================================================================
Function Pas500wGetDirections(ByVal wLogSlot As Integer, pdwDirections As Long) As Boolean
  Pas500wGetDirections = False
  If hDLL <> 0 Then
    If Pas500GetDirections(wLogSlot, pdwDirections) <> 0 Then
      Pas500wGetDirections = True
    End If
  End If
End Function
'============================================================================
'     ިڸ݂
'     wLogSlot     ިڸݏݒ肷޲̘_ۯĔԍ
'         dwDirections Ăe
'  ߂l  True
'         s False
'============================================================================
Function Pas500wSetDirections(ByVal wLogSlot As Integer, ByVal dwDirections As Long) As Boolean
  Pas500wSetDirections = False
  If hDLL <> 0 Then
    If Pas500SetDirections(wLogSlot, dwDirections) <> 0 Then
      Pas500wSetDirections = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăް
'     wLogSlot  ͂޲̘_ۯĔԍ
'         dwLogPort ͂_߰
'         pbInValue ްi[
'  ߂l  True
'         s False
'============================================================================
Function Pas500wInPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, pbInValue As Byte) As Boolean
  Pas500wInPort = False
  If hDLL <> 0 Then
    If Pas500InPort(wLogSlot, dwLogPort, pbInValue) <> 0 Then
      Pas500wInPort = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăްo
'     wLogSlot  o͂޲̘_ۯĔԍ
'         dwLogPort o͂_߰
'         bOutValue o͂ް
'  ߂l  True
'         s False
'============================================================================
Function Pas500wOutPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Boolean
  Pas500wOutPort = False
  If hDLL <> 0 Then
    If Pas500OutPort(wLogSlot, dwLogPort, bOutValue) <> 0 Then
      Pas500wOutPort = True
    End If
  End If
End Function
'============================================================================
'     PA-S500̴װ
'     wLogSlot  װ޲̘_ۯĔԍ
'  ߂l װ
'============================================================================
Function Pas500wGetLastError(ByVal wLogSlot As Integer) As Long
  If hDLL = 0 Then
    Pas500wGetLastError = PAS500_ERR_WRAPDLL
  Else
    Pas500wGetLastError = Pas500GetLastError(wLogSlot)
  End If
End Function
'---------------------------------------------------------------------------
'     DLL߰Ċ֐ڽ̎擾
'     
'  ߂l  True
'         s False
'---------------------------------------------------------------------------
Private Function Pas500wGetDllExportFunc() As Boolean
  Dim pFunc As Long
  Pas500wGetDllExportFunc = False

  ' Pas500Create ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500Create")
  If pFunc = 0 Then Exit Function
  ' Pas500Close ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500Close")
  If pFunc = 0 Then Exit Function
  ' Pas500GetResource ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500GetResource")
  If pFunc = 0 Then Exit Function
  ' Pas500GetSwitchValue ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500GetSwitchValue")
  If pFunc = 0 Then Exit Function
  ' Pas500GetDirections ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500GetDirections")
  If pFunc = 0 Then Exit Function
  ' Pas500SetDirections ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500SetDirections")
  If pFunc = 0 Then Exit Function
  ' Pas500InPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500InPort")
  If pFunc = 0 Then Exit Function
  ' Pas500OutPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500OutPort")
  If pFunc = 0 Then Exit Function
  ' Pas500GetLastError ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Pas500GetLastError")
  If pFunc = 0 Then Exit Function
  Pas500wGetDllExportFunc = True    ' SĂ DLL ߰Ċ֐ڽ擾
End Function



